-- ================================================================================
--   Database name :  COMISSARIA
--   Created on    :  11/07/2001
--   Programadora  :  Alessandra Rosa Rezende
--   @C:\Win_Prj\Sql\End_Conv\Oracle\1750_COCSTP_Adiciona_Receita.sql
-- ================================================================================
CREATE OR REPLACE PROCEDURE ADICIONA_RECEITA(
P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
P_CDRECEITAORI  IN RECEITA.CDRECEITA%TYPE,
P_CDRECEITADEST IN RECEITA.CDRECEITA%TYPE,
P_CDCIA         IN COMPANHIA.CDCIA%TYPE,
P_IDTSHATIV     IN VARCHAR2, -- P (Padro) ou L (Local)
P_IDADICIONA    IN VARCHAR2)
AS
BEGIN
   IF P_IDADICIONA = 'N' THEN

      IF P_IDTSHATIV = 'P' THEN
         DELETE FROM RENDPADRAO
         WHERE CDRECEITA = P_CDRECEITADEST;

         DELETE FROM PRORECEITA
         WHERE CDRECEITA = P_CDRECEITADEST;
         DELETE FROM SUBRECEITA
         WHERE CDRECEITA = P_CDRECEITADEST;

      ELSIF P_IDTSHATIV = 'L' THEN
         DELETE FROM RENDLOCAL
         WHERE CDRECEITA = P_CDRECEITADEST;

         DELETE FROM PRORECLOC
         WHERE CDRECEITA = P_CDRECEITADEST;
         DELETE FROM SUBRECLOC
         WHERE CDRECEITA = P_CDRECEITADEST;
      END IF;
   END IF;

   IF P_IDTSHATIV = 'P' THEN

      INSERT INTO RENDPADRAO
         (CDRECEITA, QTRENDRECPAD, QTAPRORECPAD)
      SELECT P_CDRECEITADEST, QTRENDRECPAD, QTAPRORECPAD
      FROM RENDPADRAO
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT P_CDRECEITADEST
                        FROM RENDPADRAO
                        WHERE CDRECEITA = P_CDRECEITADEST);

      INSERT INTO PRORECEITA
         (CDRECEITA, CDPRODUTO, SGUNIDADE, QTPRODREC, TXCOMREC,
          NRORDPREC)
      SELECT P_CDRECEITADEST, CDPRODUTO, SGUNIDADE, QTPRODREC,
             TXCOMREC, NRORDPREC
      FROM PRORECEITA P
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT P_CDRECEITADEST
                        FROM PRORECEITA P1
                        WHERE CDRECEITA = P_CDRECEITADEST AND
                              P.CDPRODUTO = P1.CDPRODUTO);

      INSERT INTO SUBRECEITA
         (CDRECEITA, CDSUBREC, QTRENDSUBREC, NRORDSUBREC)
      SELECT P_CDRECEITADEST, CDSUBREC, QTRENDSUBREC, NRORDSUBREC
      FROM SUBRECEITA S
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT P_CDRECEITADEST
                        FROM SUBRECEITA S1
                        WHERE CDRECEITA = P_CDRECEITADEST AND
                              S.CDSUBREC = S1.CDSUBREC);


   ELSIF P_IDTSHATIV = 'L' THEN

      INSERT INTO RENDLOCAL
         (CDRECEITA, CDFILIAL, QTRENDRECLOC, QTAPRORECLOC)
      SELECT P_CDRECEITADEST, P_CDFILIAL, QTRENDRECPAD, QTAPRORECPAD
      FROM RENDPADRAO
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT P_CDRECEITADEST, P_CDFILIAL
                        FROM RENDLOCAL
                        WHERE CDFILIAL  = P_CDFILIAL  AND
                              CDRECEITA = P_CDRECEITADEST);

      INSERT INTO PRORECLOC
         (CDPRODUTO, CDRECEITA, CDFILIAL, SGUNIDADE,
          QTPRODLOC, TXCOMLOC, NRORDPLOC)
      SELECT CDPRODUTO, P_CDRECEITADEST, P_CDFILIAL,
             SGUNIDADE, QTPRODREC, TXCOMREC, NRORDPREC
      FROM PRORECEITA P
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT CDPRODUTO,P_CDRECEITADEST,
                               P_CDFILIAL
                        FROM PRORECLOC P1
                        WHERE CDFILIAL  = P_CDFILIAL  AND
                              CDRECEITA = P_CDRECEITADEST AND
                              P.CDPRODUTO = P1.CDPRODUTO);

      INSERT INTO SUBRECLOC
         (CDRECEITA, CDFILIAL, CDSUBRECLOC, QTRENDSUBLOC, NRORDSUBLOC)
      SELECT P_CDRECEITADEST, P_CDFILIAL, CDSUBREC, QTRENDSUBREC, NRORDSUBREC
      FROM SUBRECEITA S
      WHERE CDRECEITA = P_CDRECEITAORI AND
            NOT EXISTS (SELECT P_CDRECEITADEST, P_CDFILIAL
                        FROM SUBRECLOC S1
                        WHERE CDFILIAL  = P_CDFILIAL  AND
                              CDRECEITA = P_CDRECEITADEST AND
                              S.CDSUBREC = S1.CDSUBRECLOC);
   END IF;
END;
/
